#{extends 'border.html'/}
<div class="container">
#{form @admin.UsulanCtr.submitReviewUsulan(), method:'POST', class:'form-horizontal', enctype:'multipart/form-data'}
    <div class="row">
        <div class="col-md-12">
            <!-- Breadcrumb -->
            <ol class="breadcrumb">
                <li><a href="@{PublikCtr.home()}">&{'beranda.label'}</a></li>
                <li class="active">&{'review_usulan.label'}</li>
            </ol>
            <!-- End Breadcrumb -->
        </div>
    </div>
    <div class="row">
        <div class="col-md-12">
            <!-- Toolbar -->
            <div class="toolbar">
                <a id="btnBefore">#{backButton/}</a>
                #{saveButton /}
            </div>
            <!-- End Toolbar -->
        </div>
    </div>
    <div class="row">
        <div class="col-md-12">
            #{alert /}
            <div class="panel panel-default">
                <div class="panel-body">

                    <input id="usulan-id" type="hidden" name="usulan_id" value="${usulan.id}">
                    <input type="hidden" name="usulan_id" value="${usulan.nama_usulan}">
                    <input type="hidden" id="from_page" name="from_page">
                    <div class="form-group required">
                        <label class="col-md-3 control-label">&{'unggah.label'} &{'dokumen_review_usulan'}</label>
                        <div class="col-md-4"><input type="text" class="form-control" name="dok_label" id="dokLabel" placeholder="&{'nama_dokumen.label'}" ${dokumenInfoList != null ? '' : 'required'}></div>
                        <div class="col-md-5">
                            <input id="fileupload" type="file" accept=".doc,.docx,.pdf,.xlx,.zip" name="file"  disabled>
                            <label class="control-label">&{'dokumen.label'} .DOC, .DOCX, .PDF, .XLX, .ZIP</label>
                        </div>
                    </div>

                    <div id="progress" class="progress" style="display: none;">
                        <div class="progress-bar progress-bar-success"></div>
                    </div>
                    <div class="form-group">
                        <div id="alert-upload" style="margin-top: 10px;"></div>
                        <label class="col-md-3 control-label">&{'total_file.label'}</label>
                        <div class="col-md-5">
                            <input id="file-counter" class="disabled" name="file-counter" type="text" value="${dokumenInfoList != null ? dokumenInfoList.size() : 0}" readonly style="width: 25px; border: 0px; margin-top: 5px;">
                        </div>
                    </div>

                    <div class="form-group" >
                        <label class="col-md-3 control-label">&{'daftar_file.label'}</label>
                        <div class="col-md-9">
                            <ol id="files" class="files" style="padding:15px;">
                                #{list dokumenInfoList, as:'dokumen'}
                                    <li>${dokumen.file_label} - ${dokumen.name}
                                        <a href="javascript:void(0)" class="removeDok" versi="${dokumen.versi}">
                                            <i class="fa fa-trash-o"></i></a>
                                        <input type="hidden" name="file_id" value="${dokumen.id}"/>
                                    </li>
                                #{/list}
                            </ol>
                        </div>
                    </div>

                </div>
            </div>
        </div>
    </div>
#{/form}
</div>

#{set 'moreScripts'}
<script src="@{'/public/javascripts/toast/jquery.toast.min.js'}" type="text/javascript"> </script>
<script type="text/javascript">
    // var have_child = false;
    // var current_last_level = 1;
    var totalUploaded = ${dokumenInfoList != null ? dokumenInfoList.size() : 0};

    var params = {};
    params.uploadDocUrl = '@{admin.UsulanCtr.uploadDokReview()}';
    params.deleteDocUrl = '@{admin.UsulanCtr.hapusDocReview()}';

    $(document).ready(function () {
        var from_page = $('#btnBefore .btn').attr('href');
        $('#from_page').val(from_page);

        $('#dokLabel').keyup(function () {
            var label = $(this).val();
            if(label != "" && label != null){
                $('#fileupload').attr("disabled", false);
            } else {
                $('#fileupload').attr("disabled", true);
            }
        });

        $(document).on('click', '#fileupload', function(){
            console.log("upload..");

            $('#fileupload').fileupload({
                url: params.uploadDocUrl,
                formData: {
                    'authenticityToken': $('input[name=authenticityToken]').val(),
                    dok_label: $('#dokLabel').val(),
                    'usulan_id': $('#usulan-id').val()
                },
                dataType: 'json',
                acceptFileTypes: /(\.|\/)(doc|docx|xls|xlsx|pdf|zip|)$/i,
                done: function (e, data) {
                    //console.log("upload done.."+data.result.errorx);
                    $.each(data.result.files, function (index, file) {
                        //file.id adalah blob.id
                        var content = $('#dokLabel').val() + ' - ' + file.name
                                + ' <a href="javascript:void(0)" class="removeDok" versi="'+file.versi+'" fileId="'+file.id+'">' +
                                '<i class="fa fa-trash-o" ></i></a><input type="hidden" name="file_id" value="' + file.id + '">';
                        $('<li/>').html(content).appendTo('#files');
                        totalUploaded++;
                    });
                    //$('#dokLabel').val('');
                    $('#dokLabel').change();
                    $('#progress').hide();
                    $('#alert-upload').hide();
                    $('#file-counter').val(totalUploaded);
                    $('#fileupload').attr('disabled', true).val('');
                    //validate();

                    if (data.result.errorx != null){
                        //$('#alert-upload').attr('class', 'alert alert-danger').html("&{'paket.upload_failed'}");
                        //alert("&{'paket.upload_failed'}");
                        showToast("&{'paket.upload_failed'}");
                    }
                },
                error: function (jqXHR, exception) {
                    //alert(jqXHR.status);
                    var msg = '';
                    if (jqXHR.status === 0) {
                        msg = 'Not connect.\n Verify Network.';
                    } else if (jqXHR.status == 404) {
                        msg = 'Requested page not found. [404]';
                    } else if (jqXHR.status == 500) {
                        msg = 'Internal Server Error [500].';
                    } else if (exception === 'parsererror') {
                        msg = 'Requested JSON parse failed.';
                    } else if (exception === 'timeout') {
                        msg = 'Time out error.';
                    } else if (exception === 'abort') {
                        msg = 'Ajax request aborted.';
                    } else {
                        msg = 'Uncaught Error.\n' + jqXHR.responseText;
                    }
                    alert(msg);
                },
                progressall: function (e, data) {
                    //console.log("upload run..");
                    var progress = parseInt(data.loaded / data.total * 100, 10);
                    $('#progress').show();
                    $('#progress .progress-bar').css(
                            'width',
                            progress + '%'
                    );
                }
            }).on('fileuploadprocessalways', function (e, data) {
                // console.log("upload always..");
                var file = data.files[data.index];
                if (data.files.error && file.error) {
                    var msg = file.name+' - '+file.error
                    $('#alert-upload').attr('class', 'alert alert-danger').html(msg)
                }
            }).prop('disabled', !$.support.fileInput).parent().addClass($.support.fileInput ? undefined : 'disabled');
        });

        $(document).on('click', '.removeDok', function(){
            var versi = $(this).attr('versi');
            var parent = $(this).parent();
            var fileId = $(this).attr('fileId');
            $.ajax({
                type: 'POST',
                url: params.deleteDocUrl,
                //data : {'fileId': fileId, 'versi': versi, 'authenticityToken': ('input[name=authenticityToken]').val()},
                data : {'id': fileId, 'authenticityToken': $('input[name=authenticityToken]').val()},
                success : function(){
                    $('#alert-upload').html('<div class="alert alert-success" role="alert">File telah terhapus</div>');
                    parent.remove();
                    totalUploaded--;
                    $('#file-counter').val(totalUploaded);
                    //validate();
                },
                error : function(){
                    $('#alert-upload').html('<div class="alert alert-danger" role="alert">File tidak bisa dihapus</div>');
                    //validate();
                }
            })
        });

    });

    function showToast(message) {
        jQuery.toast({
            heading: 'Oops',
            text: message,
            position: 'bottom-center',
            stack: false,
            icon: 'error',
            hideAfter: 6000
        })
    }

</script>
#{/set}